#include "/usr/src/drivers/drivers.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <minix/sysutil.h>
#include <errno.h>


#include "pci_helper.h"


/*===========================================================================*
 *			helper functions for I/O										 *
 *===========================================================================*/
PUBLIC unsigned pci_inb(U16_t port) {
	u32_t value;
	int s;
	if ((s=sys_inb(port, &value)) !=OK)
		cmn_err(0, "sys_inb failed: %d\n", s);
	return value;
}


PUBLIC unsigned pci_inw(U16_t port) {
	u32_t value;
	int s;
	if ((s=sys_inw(port, &value)) !=OK)
		cmn_err(0, "sys_inw failed: %d\n", s);
	return value;
}


PUBLIC unsigned pci_inl(U16_t port) {
	U32_t value;
	int s;

	if ((s=sys_inl(port, &value)) !=OK)
		cmn_err(0, "sys_inl failed: %d\n", s);
	return value;
}


PUBLIC void pci_outb(U16_t port, U8_t value) {
	int s;
	if ((s=sys_outb(port, value)) !=OK) {
		cmn_err(0, "sys_outb failed: %d\n", s);
	}
}


PUBLIC void pci_outw(U16_t port, U16_t value) {
	int s;
	if ((s=sys_outw(port, value)) !=OK)
		cmn_err(0, "sys_outw failed: %d\n", s);
}


PUBLIC void pci_outl(U16_t port, U32_t value) {
	int s;
	if ((s=sys_outl(port, value)) !=OK) {
		cmn_err(0, "sys_outl failed: %d\n", s);
	}
}
